/**
 * ResponseData represents a class that contains responses data and has some methods to keep these information
 * @zahra_fatehi
 * @version 0.0
 */
package com.insomnia.parser;

import java.io.*;
import java.util.List;
import java.util.Map;

public class ResponseData implements Serializable {

    private RequestData requestData;
    private long startTime,finalTime;
    private boolean syntaxError = false;
    private String syntaxErrorLog = "";
    private boolean successful = false;
    private int status = -1;
    private Map<String, List<String>> responseHeaders;
    private String errorMessage = "";
    private long size;

    /**
     * create a response data with request data
     * @param data is the request data
     */
    public ResponseData (RequestData data){
        this.requestData = data;
        startTime = System.currentTimeMillis();
    }

    /**
     * @return the time of finishing finalTime
     */
    public ResponseData finish(){
        finalTime = System.currentTimeMillis();
        return this;
    }

    /**
     * set size of requestData
     * @param size
     */
    public void setSize(long size) {
        this.size = size;
    }

    /**
     *
     * @return the size of request data
     */
    public long getSize() {
        return size;
    }

    public int getStatus() {
        return status;
    }

    public void setResponseHeaders(Map<String, List<String>> responseHeaders) {
        this.responseHeaders = responseHeaders;
    }

    public void setSuccessful(boolean successful) {
        this.successful = successful;
    }

    public String getErrorMessage() {
        return errorMessage;
    }

    public String getSyntaxErrorLog() {
        return syntaxErrorLog;
    }

    public RequestData getRequestData() {
        return requestData;
    }

    public Map<String, List<String>> getResponseHeaders() {
        return responseHeaders;
    }

    public boolean hasSyntaxError() {
        return syntaxError;
    }

    public int getResponseStatus() {
        return status;
    }

    public long getFinalTime() {
        return finalTime;
    }

    /**
     *
     * @return the time of start processing data
     */
    public long getStartTime() {
        return startTime;
    }

    /**
     *
     * @return true of processing is successful or not
     */
    public boolean isSuccessful() {
        return successful;
    }

    String res = "";


    public String getResponseString(){
        return res;
    }


    public void setSyntaxError(boolean syntaxError) {
        this.syntaxError = syntaxError;
    }

    public void setSyntaxErrorLog(String syntaxErrorLog) {
        this.syntaxErrorLog = syntaxErrorLog;
    }




    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    /**
     *
     * @param status is the status of response data
     */
    public void setStatus(int status) {
        this.status = status;
    }

}
